// File Name: ClientImpl.java
// Date: Mar 6, 2003
// Edited by: Eiji Inoue

import java.io.*;
import java.rmi.*;
import java.rmi.server.*;

class ClientImpl implements Client {
        public static final int  CMD_F16_A0_N3 = 0xE0030010;
        public static final int  CMD_F0_A0_N3  = 0xE0030000;
        public static final char COM = ',';
        public static final char QUIT = 'q';
        public static final char STAR = 's';

        public static int scmd[] = new int[100];
        public static int sdat[] = new int[100];

	static Server server;

        public ClientImpl(String host) {
                try{
                   UnicastRemoteObject.exportObject(this);
                   Server server = (Server)Naming.lookup("//"+host+"/Server");
                   server.register(this);
		   ClientImpl.server = server;
                } catch ( Exception e ) {
                   System.err.println ("Failed to setup for RMI");
                }
	}

	public void camac_exec( int l_count ) {
                int[]  s_cmd, s_dat;
                int[] array_sizes = {4096*16};
		int    s_length;
		int    j;

                try{
		System.out.println(" RMI: Client side: ");
                // to send int array

			System.out.println("   RMI: Sent CAMAC command: array length =" + l_count );
			for (int i = 0; i < l_count + 1; i++) 
			    System.out.println("      ClientImpl.scmd[" + i + "] = 0x" + Integer.toHexString( ClientImpl.scmd[i]) + ", ClientImpl.sdat[" + i + "] = 0x" + Integer.toHexString( ClientImpl.sdat[i]));

                        ClientImpl.server.camac_cmd(ClientImpl.scmd, ClientImpl.sdat, l_count );
                } catch ( Exception e ) {
                   System.err.println ("Failed to setup for RMI step2");
                }
	}

	public void camac_reply( int[] c_reply, int[] d_reply, int l_reply) throws RemoteException {
                System.out.println();
                System.out.println("   RMI: Received CAMAC reply: " + "array length = " + l_reply);
                for (int i = 0; i < l_reply + 1; i++)
                    System.out.println("      c_reply[" + i + "] = 0x" + Integer.toHexString(c_reply[i]) + ", d_reply[" + i + "] = 0x" + Integer.toHexString(d_reply[i]));

	}

// TX
// +---------+-------+-------+-------+-------+---------------------------+
// |   cmd   |   N   |   A   |   F   |       |       24-bit DATA         |
// +---------+-------+-------+-------+-------+---------------------------+
//
// cmd Header pattern
// +-------------+---------+---------+---------+---------------+
// |             | Packet  | Packet  | Packet  | Single        |
// |             | Start   | Period  | End     | Frame Packet  |
// +-------------+---------+---------+---------+---------------+
// | CAMAC       |         |         |         |               |
// | Operation   |  0xC0   |  0x8C   |  0xA0   |      0xE0     |
// +-------------+---------+---------+---------+---------------+
// | CAMAC       |         |         |         |               |
// | LAM         |   --    |   --    |   --    |      0xE8     |
// +-------------+---------+---------+---------+---------------+
// | DAQ Trigger |         |         |         |               |
// | out         |  0xD0   |  0x90   |  0xB0   |      0xF0     |
// +-------------+---------+---------+---------+---------------+
// | DAQ         |         |         |         |               |
// | Interrupt   |   --    |   --    |   --    |      0xF8     |
// +-------------+---------+---------+---------+---------------+
//
// CAMAC N.
//    55   54   53   52   51  50  49  48  47                              32
// +--------------------+----------------+-------------------+---------------+
// |   -    -    -  N16 | N8  N4  N2  N1 |         |         |       |       |
// +--------------------+----------------+-------------------+---------------+
//
// CAMAC A.
//                        47   46   45  44    43  42  41  40              32
// +--------------------+-------------------+----------------+---------------+
//                      |  -    -    -   -  | A8  A4  A2  A1 |       |       |
// +--------------------+-------------------+----------------+---------------+
//
// CAMAC F.
//                                        39   38   37   36   35  34  33  32
// +--------------------+----------------+------------------+----------------+
//                                       | -    -    -  F16 | F8  F4  F2  F1 |
// +--------------------+----------------+------------------+----------------+
//


   public void cmdbld( int n, int a, int f, int l_count ){
      // CAMAC Single action.
      System.out.println ( "   Make up CAMAC Command of Single action." );
      System.out.println ( "   Accepted data:   n = " + n + ", a = " + a + ", f = " + f + ", l_count = " + l_count );
      a = a << 8;
      n = n << 16;
      ClientImpl.scmd [ l_count -1 ] = 0xE0000000 | ( 0x0000001F & f ) | ( 0x00000F00 & a ) | ( 0x001F0000 & n );
      System.out.println ( "   ClientImpl.scmd [ " + ( l_count -1 ) + " ] = " + ClientImpl.scmd [ l_count -1 ] + "(dec), " + "0x" + Integer.toHexString( ClientImpl.scmd [ l_count -1 ] ) + "(hex)" );
      System.out.println ( "   ClientImpl.sdat [ " + ( l_count -1 ) + " ] = " + ClientImpl.sdat [ l_count -1 ] + "(dec), " + "0x" + Integer.toHexString( ClientImpl.sdat [ l_count -1 ] ) + "(hex)" );

      // CAMAC LAM handling.
      // CAMAC DMA action.
   }

   public void keyincmd() {
      char cstr[] = new char[20];
      char n[] = new char[4];
      char a[] = new char[4];
      char f[] = new char[4];
      int  c[] = new int[3];
      int  i, i2, count, loop, k_error;
      int  spoin, epoin;
      String cn = "0", ca = "0", cf = "0";
      String tmp;

      String nchk[] = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f" };

      InputStream inStream = System.in;
      InputStreamReader InData = new InputStreamReader ( inStream );

      int s_flg = 0;
      try{
         spoin = 0;
         epoin = 0;
         loop = 1;
         k_error = 0;
         System.out.println ( "" );
         System.out.println ( " (1). Enter 'q' to quit." );
         System.out.println ( " (2). Enter numerical value to sep up CAMAC command");
         System.out.println ( " (3). Enter 's' to start up command execution." );
         System.out.println ( "" );
         do {
            if ( k_error == 1 ) {
                System.out.println ( "" );
                k_error = 0;
            }
            System.out.print ( "Command (N, A, F)(dec) = " );
            count = InData.read ( cstr, 0, 19 );
            String str = new String ( cstr );

            if ( QUIT == str.charAt ( 0 ) ) {
	       s_flg = 2;
               break;
            } else if ( STAR == str.charAt ( 0 )) {
               if ( epoin == 0 ) {
                  System.out.print ( "   Command bufer is empty !!");
                  System.out.println ( "" );
                  continue;
               } else {
                  // camacstart();
		  s_flg = 1;
                  System.out.println( "   Ok. Start up CAMAC execution. " );
		  break;
               }
            }
            tmp = str.substring ( 0, count -1 );
            System.out.println ( "   Ϥ줿Command: " + tmp );
            i2 = 0;
            for ( i = 0; i < str.length(); i++ ) {
               if ( COM == str.charAt ( i ) ) {
                   c[ i2++ ] = i;
               }
            }
            cn = str.substring ( 0, c[ 0 ] );
            ca = str.substring ( c[ 0 ] +1, c[ 1 ]  );
            cf = str.substring ( c[ 1 ] +1, count-1 );

            try{
               int in = Integer.parseInt(cn, 10);
               if ( ( in < 0 ) || ( in > 25 ) ) {
                   System.out.println ( "   Command Error: Illegal value of N: Out of range !! " );
                   k_error = 1;
                   continue;
               }
               int ia = Integer.parseInt(ca, 10);
               if ( ( ia < 0 ) || ( ia > 15 ) ) {
                   System.out.println ( "   Command Error: Illegal value of A: Out of range !! " );
                   k_error = 1;
                   continue;
               }
               int inf = Integer.parseInt(cf, 10);
               if ( ( inf < 0 ) || ( inf > 31 ) ) {
                   System.out.println ( "   Command Error: Illegal value of F: Out of range !! " );
                   k_error = 1;
                   continue;
               }

               if ( ( inf >= 16 ) && ( inf <= 23 ) ) {
                  // ǡ׵
                  int datf = 0;
                  do {
                  System.out.print ( "   Write Data(hex) = " );
                  count = InData.read ( cstr, 0, 19 );
                  str = new String ( cstr );
                  String cdat = str.substring ( 0, count -1 );
                  for ( i = 0; i < count -1; i++) {
                     String cdat1 = cdat.substring ( i, i + 1 );
                     // numerical check
                     for ( i2 = 0; i2 < 16; i2++ ) {
                        if ( cdat1.equals( nchk [ i2 ] ) ) {
                           datf = 0;
                           break;
                        }
                           datf = 1;
                     }
                     if ( datf == 1 ) {
                        System.out.println ( "   Data error: Illegal character --- " + cdat1 + " !" );
                        System.out.println ( "" );
                        break;
                     }
                  }
                  if ( datf == 1) {
                     continue;
                  }
                  ClientImpl.sdat [ loop -1 ] = Integer.parseInt( cdat, 16);
                  System.out.println ( "   Ϥ줿Data:  " + ClientImpl.sdat [ loop -1 ] + "(dec), 0x" + Integer.toHexString( ClientImpl.sdat [ loop -1 ] ) + "(hex)");
                  if ( ( ClientImpl.sdat [ loop -1 ] < 0 ) || ( ClientImpl.sdat [ loop -1 ] > 0xffffff ) ) {
                     System.out.println ( "   Data error: Out of range ---  " + ClientImpl.sdat [ loop -1 ] + " !" );
                     System.out.println ( "" );
                     datf = 1;
                     continue;
                  }
                  } while ( datf == 1 );
               }

               // CAMAC command set up.
               cmdbld ( in, ia, inf, loop );
               epoin++;
               loop++;
               System.out.println ( "" );

            } catch (NumberFormatException e) {
               System.out.println("   NumberFormatException occurred !!");
               System.out.println ( "" );
            }
         } while ( loop > 1 );
 	    if ( s_flg == 1 ) {
//               System.out.println ( "   CAMAC execution. " );
	       camac_exec( loop -1 );
	 } else if ( s_flg == 2 ) {
	    System.out.println ( "    Quited Program.  Enter Ctl-C. " );
	 }

         } catch ( IOException e ) {
            System.out.println ( "   IOException Error:" + e  + " !");
         }
      }


	public static void main(String argv[]) throws Exception{
	
		String  host = (argv.length == 1) ? argv[0] : "localhost";
		ClientImpl obj = new ClientImpl(host);
		obj.keyincmd();
	}
}
